from typing import Any, Text, Dict, List
from rasa_sdk import Action, Tracker
from rasa_sdk.events import SessionStarted,UserUtteranceReverted,ConversationPaused,ConversationResumed

class ActionActionListen(Action):
    def name(self) -> Text:
        return "action_listen"

    async def run(
      self, dispatcher, tracker: Tracker, domain: Dict[Text, Any]
    ) -> List[Dict[Text, Any]]:
        print('---- CUSTOM action_action_listen ----')
        is_auth = tracker.get_slot('is_auth')

        show_without_authentication = ['help_login']
        if not is_auth:
            _response = None
            current_intent = tracker.latest_message['intent'].get('name')
            if current_intent in show_without_authentication:
                _response = current_intent
            else:
                _response = "utter_please_make_login"
            dispatcher.utter_message(response=_response)
            return []

        return [dispatcher, tracker, domain]